

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>News - 4.x &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script src="../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../ja/html/news/4.x.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="nav-item nav-item-0"><a href="../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">News - 4.x</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="news-4-x">
<h1>News - 4.x<a class="headerlink" href="#news-4-x" title="Permalink to this headline">¶</a></h1>
<div class="section" id="release-4-1-1-2015-01-29">
<span id="release-4-1-1"></span><h2>Release 4.1.1 - 2015-01-29<a class="headerlink" href="#release-4-1-1-2015-01-29" title="Permalink to this headline">¶</a></h2>
<div class="section" id="improvements">
<h3>Improvements<a class="headerlink" href="#improvements" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>[windows] Improved to show error message instead of
error code. It’s easy to understand.</p></li>
<li><p>[experimental][windows] Supported small start file size for database file.
In previous versions, Groonga consumed larger initial file
size on windows in contrast to UNIX like environment.
To enable this feature, use <code class="docutils literal notranslate"><span class="pre">GRN_IO_VERSION=1</span></code> environment
variable. This feature isn’t enabled by default because it is in experimental stage.</p></li>
<li><p>Supported <code class="docutils literal notranslate"><span class="pre">SUM</span></code>, <code class="docutils literal notranslate"><span class="pre">MIN</span></code>, <code class="docutils literal notranslate"><span class="pre">MAX</span></code>, <code class="docutils literal notranslate"><span class="pre">AVG</span></code> feature for drilldown.
This feature is supported by extending newer drilldown syntax which supports label.
Specify <code class="docutils literal notranslate"><span class="pre">SUM</span></code>, <code class="docutils literal notranslate"><span class="pre">MIN</span></code>, <code class="docutils literal notranslate"><span class="pre">MAX</span></code> or <code class="docutils literal notranslate"><span class="pre">AVG</span></code> for <a class="reference internal" href="../reference/commands/select.html#select-drilldown-calc-types"><span class="std std-ref">drilldown_calc_types</span></a>
and target column for <a class="reference internal" href="../reference/commands/select.html#select-drilldown-calc-target"><span class="std std-ref">drilldown_calc_target</span></a>.
The return value is calculated based on drilldown result in group.</p></li>
<li><p>[experimental] Added <code class="docutils literal notranslate"><span class="pre">--with-jemalloc</span></code> option to use <code class="docutils literal notranslate"><span class="pre">jemalloc</span></code> for <code class="docutils literal notranslate"><span class="pre">malloc()/free()</span></code>.
It’ll improve performance on multi-threading usage. For example, the performance
of <a class="reference internal" href="../reference/executables/groonga.html"><span class="doc">groonga executable file</span></a> or <a class="reference external" href="http://mroonga.org/">Mroonga</a> will be improved.
Note that this feature doesn’t affect to <a class="reference internal" href="../reference/executables/groonga-httpd.html"><span class="doc">groonga-httpd</span></a> because
groonga-httpd uses multi-process model instead of multi-threading.</p></li>
<li><p>groonga-httpd: Supported long error message over 2048 bytes.
By this change, long error message (&gt;2048) is not truncated.</p></li>
<li><p>[<a class="reference internal" href="../reference/commands/dump.html"><span class="doc">dump</span></a>] Supported streaming output.</p></li>
</ul>
</div>
<div class="section" id="fixes">
<h3>Fixes<a class="headerlink" href="#fixes" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>Fixed mismatch between error code and error message when
<code class="docutils literal notranslate"><span class="pre">strerror()</span></code> is failed. There was a case that Groonga shows
incorrect error code as syscall error.</p></li>
<li><p>Fixed to show errno in error message when unknow error is occurred.</p></li>
<li><p>[windows] Fixed to return proper error code.</p></li>
<li><p>Fixed a bug that there is only one section for multi-column index for
<a class="reference internal" href="../reference/commands/select.html#select-match-columns"><span class="std std-ref">match_columns</span></a>, it doesn’t return correct search results.
For example, consider the case that there is multi-column index which is
named as <code class="docutils literal notranslate"><span class="pre">memo_index</span></code> for <code class="docutils literal notranslate"><span class="pre">title</span></code> column and <code class="docutils literal notranslate"><span class="pre">content</span></code> column.
Thus, this bug occurs when <code class="docutils literal notranslate"><span class="pre">memo_index[0]</span></code> which means index
for <code class="docutils literal notranslate"><span class="pre">title</span></code> column is specified for <a class="reference internal" href="../reference/commands/select.html#select-match-columns"><span class="std std-ref">match_columns</span></a>.</p></li>
<li><p>mecab: Added workaround for <code class="docutils literal notranslate"><span class="pre">mecab_strerror(NULL)</span></code> on MeCab 0.993.
Without this workaround, Groonga aborts if there is no MeCab
dictionary. [Reported by Shuhei Tanuma]</p></li>
<li><p>groonga-httpd: Fixed a bug that custom log file is ignored.</p></li>
<li><p>groonga-httpd: Fixed a bug that empty dump doesn’t return.</p></li>
</ul>
</div>
<div class="section" id="thanks">
<h3>Thanks<a class="headerlink" href="#thanks" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>Shuhei Tanuma</p></li>
</ul>
</div>
</div>
<div class="section" id="release-4-1-0-2015-01-09">
<span id="release-4-1-0"></span><h2>Release 4.1.0 - 2015-01-09<a class="headerlink" href="#release-4-1-0-2015-01-09" title="Permalink to this headline">¶</a></h2>
<p>It’s a bug fix release of 4.0.9.</p>
<p>If you have already upgraded to 4.0.9, please upgrade to 4.1.0. And
re-create your all indexes. You can re-create your indexes by removing
and re-creating your indexes such as:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>column_remove TABLE INDEX_COLUMN
column_create TABLE INDEX_COLUMN COLUMN_INDEX|...
</pre></div>
</div>
<div class="admonition seealso">
<p class="admonition-title">See also</p>
<ul class="simple">
<li><p><a class="reference internal" href="../reference/commands/column_remove.html"><span class="doc">column_remove</span></a></p></li>
<li><p><a class="reference internal" href="../reference/commands/column_create.html"><span class="doc">column_create</span></a></p></li>
</ul>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>If you didn’t change your indexes by Groonga 4.0.9, you don’t need
to re-create your indexes. “change” means “add”, “remove” and
“update”. If you use your indexes only for “search” by Groonga
4.0.9, you don’t need to re-create your indexes.</p>
</div>
<div class="section" id="id1">
<h3>Fixes<a class="headerlink" href="#id1" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>Fixed a bug that index may be broken. But the following bug fixed in
Groonga 4.0.9 is re-appeared.</p>
<ul>
<li><p>Fixed a crash bug that may be occurred by deleting or updating many
indexed values at once.
[groonga-dev,02942] [Reported by kashihara]</p></li>
</ul>
</li>
</ul>
</div>
</div>
<div class="section" id="release-4-0-9-2014-12-29">
<span id="release-4-0-9"></span><h2>Release 4.0.9 - 2014-12-29<a class="headerlink" href="#release-4-0-9-2014-12-29" title="Permalink to this headline">¶</a></h2>
<div class="admonition caution">
<p class="admonition-title">Caution</p>
<p>Use 4.1.0 instead of 4.0.9. 4.0.9 has a serious bug that may break
index.</p>
</div>
<div class="section" id="id2">
<h3>Improvements<a class="headerlink" href="#id2" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>[<a class="reference internal" href="../reference/executables/groonga-httpd.html"><span class="doc">groonga-httpd</span></a>] Marked as stable.</p></li>
<li><p>[doc] Described about <code class="docutils literal notranslate"><span class="pre">groonga-token-filter-stem</span></code> package.
[GitHub#259] [Patch by Masafumi Yokoyama]</p></li>
<li><p>[build] Supported <code class="docutils literal notranslate"><span class="pre">make</span> <span class="pre">install</span></code> without <code class="docutils literal notranslate"><span class="pre">make</span></code>.
[Reported by akira yamada]</p></li>
<li><p>[experimental] Added <a class="reference internal" href="../reference/commands/request_cancel.html"><span class="doc">request_cancel</span></a>
command that cancels running request.</p></li>
<li><p>[experimental] Added <a class="reference internal" href="../reference/api/grn_db.html#c.grn_db_recover" title="grn_db_recover"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_db_recover()</span></code></a>.</p></li>
<li><p>Supported indexing vector of fixed size data such as vector of
<code class="docutils literal notranslate"><span class="pre">UInt64</span></code>.
[groonga-dev,03014] [Reported by funa 1g]</p></li>
<li><p>[experimental] Added <a class="reference internal" href="../reference/executables/grndb.html"><span class="doc">grndb</span></a>.</p></li>
<li><p>[deb] Supported armhf architecture.</p></li>
<li><p>[<a class="reference internal" href="../reference/executables/groonga-server-http.html"><span class="doc">Groonga HTTP server</span></a>] Supported HEAD.</p></li>
<li><p>[doc] Updated <a class="reference internal" href="../contribution/documentation/introduction.html"><span class="doc">Introduction</span></a>.
[GitHub#270] [Patch by Yuya TAMANO]</p></li>
<li><p>[doc] Updated <a class="reference internal" href="../install/others.html"><span class="doc">Others</span></a>.
[GitHub#271] [Patch by Hiroshi Hatake]</p></li>
<li><p>[<a class="reference internal" href="../reference/token_filters/token_filter_stem.html#token-filter-stem"><span class="std std-ref">TokenFilterStem</span></a>] Supported token that consists with only
upper-case alphabets, digits, <code class="docutils literal notranslate"><span class="pre">-</span></code> and <code class="docutils literal notranslate"><span class="pre">'</span></code>. It means that
<a class="reference internal" href="../reference/token_filters/token_filter_stem.html#token-filter-stem"><span class="std std-ref">TokenFilterStem</span></a> can work with MySQL compatible normalizers.</p></li>
<li><p>[<a class="reference internal" href="../reference/commands/truncate.html"><span class="doc">truncate</span></a>] Supported column.</p></li>
<li><p>[<a class="reference internal" href="../reference/commands/truncate.html"><span class="doc">truncate</span></a>] Changed parameter name to
<code class="docutils literal notranslate"><span class="pre">target_name</span></code> from <code class="docutils literal notranslate"><span class="pre">table</span></code>. <code class="docutils literal notranslate"><span class="pre">table</span></code> parameter can be used for
backward compatibility but it shouldn’t used for newly written code.</p></li>
<li><p>Exported <a class="reference internal" href="../reference/api/grn_column.html#c.grn_column_truncate" title="grn_column_truncate"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_column_truncate()</span></code></a>.</p></li>
<li><p>Added <a class="reference internal" href="../reference/commands/lock_clear.html"><span class="doc">lock_clear</span></a>.</p></li>
<li><p>Marked <a class="reference internal" href="../reference/commands/clearlock.html"><span class="doc">clearlock</span></a> deprecated.</p></li>
<li><p>[backward incompatible] Stopped to set world writable permission for
newly created files on <code class="docutils literal notranslate"><span class="pre">umask(0)</span></code> environment such as daemoned
<a class="reference internal" href="../reference/executables/groonga-httpd.html"><span class="doc">groonga-httpd</span></a>. It’s a backward
incompatible change but done because the previous behavior has
a security risk.</p></li>
</ul>
</div>
<div class="section" id="id3">
<h3>Fixes<a class="headerlink" href="#id3" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>Fixed build error on BSD based system.
[GitHub#253] [Reported by Hiroshi Hatake]</p></li>
<li><p>Fixed build error on OS X.
[GitHub#253] [Reported by Hiroshi Hatake]</p></li>
<li><p>Fixed a regression bug that equal operation against nonexistent
reference always matches.</p></li>
<li><p>Fixed a crash bug that may be occurred by deleting or updating many
indexed values at once.
[groonga-dev,02942] [Reported by kashihara]</p></li>
<li><p>Fixed a regression bug that static index construction doesn’t work
on BSD based system. [GitHub#264] [Reported by Ayumu Osanai]</p></li>
<li><p>Fixed a bug that <code class="docutils literal notranslate"><span class="pre">--with-libstemmer</span></code> configure option is ignored.</p></li>
<li><p>[deb] Fixed a bug that logrotate script has a syntax error.</p></li>
<li><p>Fixed a bug that grouped result can’t be got when
<a class="reference internal" href="../reference/command/command_version.html"><span class="doc">Command version</span></a> is <code class="docutils literal notranslate"><span class="pre">2</span></code>.
[GitHub ranguba/rroonga#38] [Reported by YUKI “Piro” Hiroshi]</p></li>
</ul>
</div>
<div class="section" id="id4">
<h3>Thanks<a class="headerlink" href="#id4" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>Hiroshi Hatake</p></li>
<li><p>Masafumi Yokoyama</p></li>
<li><p>akira yamada</p></li>
<li><p>kashihara</p></li>
<li><p>Ayumu Osanai</p></li>
<li><p>funa 1g</p></li>
<li><p>YUKI “Piro” Hiroshi</p></li>
<li><p>Yuya TAMANO</p></li>
</ul>
</div>
</div>
<div class="section" id="release-4-0-8-2014-11-29">
<span id="release-4-0-8"></span><h2>Release 4.0.8 - 2014-11-29<a class="headerlink" href="#release-4-0-8-2014-11-29" title="Permalink to this headline">¶</a></h2>
<div class="section" id="id5">
<h3>Improvements<a class="headerlink" href="#id5" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>[deb] Supported Ubuntu 12.04 again because Travis-CI runs on it.</p></li>
<li><p>[mruby] Supported pretty print - <code class="docutils literal notranslate"><span class="pre">&quot;pp&quot;</span></code> for debugging. And supported to
show internal objects more descriptive format when inspecting it.</p></li>
<li><p>Supported full text search query without index if one column is specified
for <code class="docutils literal notranslate"><span class="pre">--match_columns</span></code> even though sequential search is executed
by <code class="docutils literal notranslate"><span class="pre">--query</span></code> and <code class="docutils literal notranslate"><span class="pre">--match_columns</span></code> combination.
[groonga-dev,02902] [Reported by Atsushi Shinoda]</p></li>
<li><p>[experimental] <a class="reference internal" href="../reference/functions/in_values.html"><span class="doc">in_values</span></a> supports auto sequential
search mode. There is a case that sequential search is faster than index search when
the number of narrowed down records is small enough in contrast to
the number of expected records to narrow down by <code class="docutils literal notranslate"><span class="pre">in_values</span></code> with
<code class="docutils literal notranslate"><span class="pre">AND</span></code> operation which use indexes.
The value of <code class="docutils literal notranslate"><span class="pre">GRN_IN_VALUES_TOO_MANY_INDEX_MATCH_RATIO</span></code> is used as
threshold whether Groonga execute sequential search or search with indexes in
such a case.</p></li>
<li><p>[mruby] Supported to load relative path of script.</p></li>
<li><p>Supported test suite to write query optimizer test more easily with
mruby enabled build.</p></li>
<li><p>Supported offline index construction for token filters.
[GitHub#239] [Patch by Naoya Murakami]</p></li>
<li><p>[experimental] <a class="reference internal" href="../reference/functions/between.html"><span class="doc">between</span></a> supports auto sequential search mode.
Use the value of <code class="docutils literal notranslate"><span class="pre">GRN_BETWEEN_TOO_MANY_INDEX_MATCH_RATIO</span></code> as threshold.
Basic concept is similar to <code class="docutils literal notranslate"><span class="pre">GRN_IN_VALUES_TOO_MANY_INDEX_MATCH_RATIO</span></code>.</p></li>
<li><p>[experimental] Supported multiple drilldowns for <a class="reference internal" href="../reference/commands/select.html"><span class="doc">select</span></a>
command. The syntax is extended to support this feature. The new one is
<code class="docutils literal notranslate"><span class="pre">--drilldown[LABEL1].keys</span> <span class="pre">COLUMN1,COLUMN2</span></code> for keys,
<code class="docutils literal notranslate"><span class="pre">--drilldown[LABEL1].output_columns</span> <span class="pre">_value.COLUMN1,_value.COLUMN2,_nsubrecs</span></code> for output columns.
In the previous versions, a client application must implement by oneself for drilldown
by multiple keys. Use <code class="docutils literal notranslate"><span class="pre">_key[N]</span></code> for <code class="docutils literal notranslate"><span class="pre">--drilldown[LABEL1].output_columns</span></code> to show
original value of key in records.</p></li>
<li><p>Supported to search <code class="docutils literal notranslate"><span class="pre">'reference_column</span> <span class="pre">&#64;</span> <span class="pre">&quot;query&quot;'</span></code> without index.</p></li>
<li><p>[experimental] Added <a class="reference internal" href="../reference/commands/range_filter.html"><span class="doc">range_filter</span></a>
command. It is faster than <a class="reference internal" href="../reference/commands/select.html"><span class="doc">select</span></a> command
to fetch specific range of records in most cases, because it doesn’t
returns the number of matched records. There are limitations which
doesn’t support drilldown and so on.  Thus, <code class="docutils literal notranslate"><span class="pre">range_filter</span></code> is
suitable for extracting first <code class="docutils literal notranslate"><span class="pre">N</span></code> records in specific range for
ranking or something else.</p></li>
<li><p>[httpd] Supported <code class="docutils literal notranslate"><span class="pre">groonga-httpd</span></code> on windows.</p></li>
<li><p>Supported vector column for drilldown.</p></li>
<li><p>[deb] Changed <code class="docutils literal notranslate"><span class="pre">groonga-httpd</span></code> as default HTTP server package.
<code class="docutils literal notranslate"><span class="pre">groonga-server-http</span></code> is deprecated. Note that <a class="reference internal" href="../reference/executables/groonga-server-http.html"><span class="doc">Groonga HTTP server</span></a>
functionality itself is still exists in Groonga. If you just want to use simple HTTP server
in traditional way, specify proper arguments by command line for <a class="reference internal" href="../reference/executables/groonga.html"><span class="doc">groonga executable file</span></a>.</p></li>
<li><p>Added configuration file for Windows CI on AppVeyor.
[groonga-dev,02970,02981] [Patch by Hiroshi Hatake]</p></li>
</ul>
</div>
<div class="section" id="id6">
<h3>Fixes<a class="headerlink" href="#id6" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>[doc] Fixed duplicated execution example path about
<a class="reference internal" href="../reference/commands/table_create.html"><span class="doc">table_create</span></a>.
[GitHub groonga.org#14] [Reported by Masafumi Yokoyama]</p></li>
<li><p>Fixed a bug that nested indexed full text search against <code class="docutils literal notranslate"><span class="pre">X._key</span></code>
returns empty results.</p></li>
<li><p>Fixed flags parameter which is strict in BSD <code class="docutils literal notranslate"><span class="pre">mkostemp(3)</span></code>.
[GitHub#240] [Patch by Jun Kuriyama]</p></li>
<li><p>Fixed a bug that <a class="reference internal" href="../reference/commands/select.html"><span class="doc">select</span></a> command reports
invalid value type (table) as index column value type. It was fixed
to <code class="docutils literal notranslate"><span class="pre">UInt32</span></code>.  Note that it affects only the value of response
header.  The search results is not changed at all.</p></li>
<li><p>Fixed a bug that compare operations such as <code class="docutils literal notranslate"><span class="pre">&lt;</span></code>, <code class="docutils literal notranslate"><span class="pre">&lt;=</span></code>, <code class="docutils literal notranslate"><span class="pre">&gt;</span></code>, <code class="docutils literal notranslate"><span class="pre">&gt;=</span></code>, <code class="docutils literal notranslate"><span class="pre">!=</span></code> with
Time and String type returns invalid results.</p></li>
<li><p>Fixed a bug that prefix search can’t be executed against single character such as
<code class="docutils literal notranslate"><span class="pre">&quot;x*&quot;</span></code>. [GitHub#242] [Patch by Naoya Murakami]</p></li>
<li><p>Fixed a memory leak on drilldown <code class="docutils literal notranslate"><span class="pre">ShortText</span></code> value with <code class="docutils literal notranslate"><span class="pre">--filter</span></code>.</p></li>
<li><p>Fixed missing <code class="docutils literal notranslate"><span class="pre">&quot;,&quot;</span></code> for <code class="docutils literal notranslate"><span class="pre">&quot;DDL:set_token_filters&quot;</span></code> log.
[Reported by Naoya Murakami]</p></li>
</ul>
</div>
<div class="section" id="id7">
<h3>Thanks<a class="headerlink" href="#id7" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>Atsushi Shinoda</p></li>
<li><p>Masafumi Yokoyama</p></li>
<li><p>Naoya Murakami</p></li>
<li><p>Jun Kuriyama</p></li>
<li><p>Hiroshi Hatake</p></li>
</ul>
</div>
</div>
<div class="section" id="release-4-0-7-2014-10-29">
<span id="release-4-0-7"></span><h2>Release 4.0.7 - 2014-10-29<a class="headerlink" href="#release-4-0-7-2014-10-29" title="Permalink to this headline">¶</a></h2>
<div class="section" id="id8">
<h3>Improvements<a class="headerlink" href="#id8" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>[windows] Supported Groonga with mruby on Windows.</p></li>
<li><p>Added token filter plugin API.</p></li>
<li><p>Added <a class="reference internal" href="../reference/token_filters/token_filter_stop_word.html#token-filter-stop-word"><span class="std std-ref">TokenFilterStopWord</span></a> token filter plugin.
It treats records of <code class="docutils literal notranslate"><span class="pre">is_stop_word</span></code> column as actual stop words.</p></li>
<li><p>[doc] Added <a class="reference internal" href="../client.html"><span class="doc">Client</span></a> section which introduces link to client libraries.
[GitHub#210] [Patch by Naoya Murakami]</p></li>
<li><p>[doc] Reconstructed documentation. <a class="reference internal" href="../reference/suggest.html"><span class="doc">Suggest</span></a> and
<a class="reference internal" href="../reference/operations/geolocation_search.html"><span class="doc">Geolocation search</span></a> are grouped under <a class="reference internal" href="../reference.html"><span class="doc">Reference manual</span></a>.
[GitHub#206] [Patch by Naoya Murakami]</p></li>
<li><p>[deb] Added stop word token filter plugin.
[GitHub#216] [Patch by Hiroshi Hatake]</p></li>
<li><p>[deb] Clarified licenses about used/bundled files in debian/copyright.</p></li>
<li><p>Dropped LZO compression support.</p></li>
<li><p>Added LZ4 compression support. [GitHub#223] [Patch by Naoya Murakami]</p></li>
<li><p>Added <a class="reference internal" href="../reference/functions/in_values.html"><span class="doc">in_values</span></a>. We recommends to use it
instead of <code class="docutils literal notranslate"><span class="pre">==</span></code> and <code class="docutils literal notranslate"><span class="pre">OR</span></code> combinations ( <code class="docutils literal notranslate"><span class="pre">((COLUMN</span> <span class="pre">==</span> <span class="pre">&quot;a&quot;)</span> <span class="pre">OR</span>
<span class="pre">(COLUMN</span> <span class="pre">==</span> <span class="pre">&quot;b&quot;)</span> <span class="pre">OR</span> <span class="pre">(COLUMN</span> <span class="pre">==</span> <span class="pre">&quot;c&quot;))</span></code> ) because of better
performance.</p></li>
<li><p>[load] Supported to update existing record in <code class="docutils literal notranslate"><span class="pre">TABLE_NO_KEY</span></code> by
specifying a record by <code class="docutils literal notranslate"><span class="pre">_id</span></code>.</p></li>
<li><p>Added <a class="reference internal" href="../reference/token_filters/token_filter_stem.html#token-filter-stem"><span class="std std-ref">TokenFilterStem</span></a> token filter plugin. It provides
stemming feature.  To use this token filter, you need to install
<a class="reference external" href="http://http://snowball.tartarus.org/">libstemmer</a> library.</p></li>
<li><p>[doc] Added <a class="reference internal" href="../reference/token_filters.html"><span class="doc">Token filters</span></a> documentation.
[GitHub#227] [Patch by Naoya Murakami]</p></li>
</ul>
</div>
<div class="section" id="id9">
<h3>Fixes<a class="headerlink" href="#id9" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>[doc] Fixed link of the Ranguba project. [GitHub#212] [Patch by Naoya Murakami]</p></li>
<li><p>[httpd] Updated bundled nginx version to 1.7.6.
[GitHub#208] [Patch by Hiroshi Hatake]</p></li>
<li><p>[power8] Fixed build failure. See
<a class="reference external" href="http://lists.askmonty.org/pipermail/commits/2014-October/006752.html">http://lists.askmonty.org/pipermail/commits/2014-October/006752.html</a>
[Patch by Sergey Vojtovich]</p></li>
<li><p>Fixed a bug that URL encoding fails if <code class="docutils literal notranslate"><span class="pre">char</span></code> type is build as
<code class="docutils literal notranslate"><span class="pre">unsigned</span> <span class="pre">char</span></code> type. [GitHub#217]</p></li>
<li><p>Fixed a bug that a <code class="docutils literal notranslate"><span class="pre">TABLE_DAT_KEY</span></code> table returns empty results for
<a class="reference internal" href="../reference/commands/select.html"><span class="doc">select</span></a>. [GitHub#220]</p></li>
<li><p>Fixed a memory leak about inspecting vector column. It occurs when
something error reports about vector column.</p></li>
<li><p>Fixed memory leaks in zlib/LZO compressed column [GitHub#221] [Patch
by Naoya Murakami]</p></li>
<li><p>Fixed a bug that the value of <code class="docutils literal notranslate"><span class="pre">Int8</span></code> column which is less than 100 may
return true in <code class="docutils literal notranslate"><span class="pre">--filter</span></code>. By this issue, not intended records may
be included as search results.</p></li>
<li><p>Fixed to handle binary operation for vector column as an error.</p></li>
<li><p>Fixed a bug that <code class="docutils literal notranslate"><span class="pre">!XXX</span></code> may return inverted result on big endian
environment.</p></li>
<li><p>Fixed a memory leak on converting weight vector to text.</p></li>
<li><p>[dump] Fixed token filters and <code class="docutils literal notranslate"><span class="pre">TABLE_NO_KEY</span></code> related error in
<a class="reference internal" href="../reference/commands/dump.html"><span class="doc">dump</span></a>.  [GitHub#215] [Patch by Naoya
Murakami]</p></li>
</ul>
</div>
<div class="section" id="id10">
<h3>Thanks<a class="headerlink" href="#id10" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>Naoya Murakami</p></li>
<li><p>Hiroshi Hatake</p></li>
<li><p>Sergey Vojtovich</p></li>
</ul>
</div>
</div>
<div class="section" id="release-4-0-6-2014-09-29">
<span id="release-4-0-6"></span><h2>Release 4.0.6 - 2014-09-29<a class="headerlink" href="#release-4-0-6-2014-09-29" title="Permalink to this headline">¶</a></h2>
<div class="section" id="id11">
<h3>Improvements<a class="headerlink" href="#id11" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>[deb] Updated to follow the rule about machine-readable
debian/copyright file. [Reported by Hideki Yamane]</p></li>
<li><p>[deb][rpm] Changed to use signal instead of HTTP to control nginx.
This way meets nginx style init script.</p></li>
<li><p>[doc] Updated English documentation about [ <a class="reference internal" href="../reference/executables.html"><span class="doc">Executables</span></a> ].
[GitHub#196] [Patch by Masafumi Yokoyama]</p></li>
<li><p>[OS X] Added missing sphinx error message for Homebrew users.
[GitHub#198] [Patch by cosmo0920]</p></li>
<li><p>[mruby] Query optimizer by mruby became a practical for some range select query.
For example, mruby optimizer overhead is negligible enough for query such as
“between(X, 0, ‘exclude’, 100, ‘include’)” - “X &gt; 0 &amp;&amp; X &lt;= 100”.</p></li>
<li><p>[doc] Changed to recommend GitHub for reporting issues.
Until now, Redmine account must be approved by administrator, so you can not
report at feel free. [GitHub#202] [Patch by cosmo0920]</p></li>
<li><p>[doc] Translated C API document. [GitHub#203] [Patch by NOKUBI Takatsugu]</p></li>
<li><p>Supported to customize similarity threshold by <code class="docutils literal notranslate"><span class="pre">'*S10&quot;...&quot;'</span></code> syntax.</p></li>
<li><p>Added source column validation to
<a class="reference internal" href="../reference/commands/column_create.html"><span class="doc">column_create</span></a>.  If source column doesn’t
exist, <a class="reference internal" href="../reference/commands/column_create.html"><span class="doc">column_create</span></a> returns <code class="docutils literal notranslate"><span class="pre">false</span></code> and
column isn’t created.</p></li>
<li><p>[debian] Dropped Debian jessie and sid support.</p></li>
</ul>
</div>
<div class="section" id="id12">
<h3>Fixes<a class="headerlink" href="#id12" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>Fixed a bug that similar search doesn’t use IDF (Inverse Document Frequency)
for choosing target tokens.
In the previous versions, it used token ID instead of IDF.
[groonga-dev,02731] [groonga-dev,02754] [Reported by Satoshi Mitani, warp kawada]</p></li>
<li><p>Fixed a crash bug when deleting a record.
If the table of the record has <code class="docutils literal notranslate"><span class="pre">_key</span></code> and <code class="docutils literal notranslate"><span class="pre">_key</span></code> is
indexed from two or more index columns, deleting causes a crash.</p></li>
<li><p>Fixed compiler warning about unused variable ‘e’. [GitHub#197] [Patch by cosmo0920]</p></li>
<li><p>[fedora][httpd] Fixed service start failure without log directory.</p></li>
<li><p>[mruby] Fixed build error with <code class="docutils literal notranslate"><span class="pre">--disable-mruby</span></code>.
[GitHub#200] [Patch by cosmo0920]</p></li>
<li><p>Fixed build warning about CMP0014 for MariaDB bundled Mroonga package.
[GitHub#201] [Patch by cosmo0920]</p></li>
<li><p>Fixed a bug that “*” is parsed as prefix search with empty string.
[groonga-dev,02796] [Reported by Kazuhiko]</p></li>
<li><p>[httpd] Updated bundled nginx version to the latest mainline (1.7.5).
This update contains vulnerability fix (CVE-2014-3616).</p></li>
</ul>
</div>
<div class="section" id="id13">
<h3>Thanks<a class="headerlink" href="#id13" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>Hideki Yamane</p></li>
<li><p>Masafumi Yokoyama</p></li>
<li><p>cosmo0920</p></li>
<li><p>NOKUBI Takatsugu</p></li>
<li><p>Satoshi Mitani</p></li>
<li><p>warp kawada</p></li>
<li><p>Kazuhiko</p></li>
</ul>
</div>
</div>
<div class="section" id="release-4-0-5-2014-08-29">
<span id="release-4-0-5"></span><h2>Release 4.0.5 - 2014-08-29<a class="headerlink" href="#release-4-0-5-2014-08-29" title="Permalink to this headline">¶</a></h2>
<div class="section" id="id14">
<h3>Improvements<a class="headerlink" href="#id14" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>Dropped Ubuntu 13.10 (Saucy Salamander).</p></li>
<li><p>Supported to show weight vector element as XML.</p></li>
<li><p>[ <a class="reference internal" href="../reference/functions/between.html"><span class="doc">between</span></a> ] Supported outside of key range.
[GitHub#183] [Patch by Naoya Murakami]</p></li>
<li><p>[mruby] Changed to use Onigmo as regexp implementation.</p></li>
<li><p>Added <a class="reference internal" href="../reference/functions/highlight_full.html"><span class="doc">highlight_full</span></a> and
<a class="reference internal" href="../reference/functions/highlight_html.html"><span class="doc">highlight_html</span></a> which tags
output text. [GitHub#185] [Patch by Naoya Murakami]</p></li>
<li><p>[doc] Updated outdated functions/commands reference
[GitHub#188] [GitHub#189] [Patch by Naoya Murakami]</p></li>
<li><p>[benchmark] Added average and median in benchmark result.</p></li>
<li><p>Exported <code class="xref c c-func docutils literal notranslate"><span class="pre">grn_selector_func()</span></code> and <code class="xref c c-func docutils literal notranslate"><span class="pre">grn_proc_set_selector()</span></code>
for plugin developer. [GitHub#190] [Patch by Naoya Murakami]</p></li>
<li><p>[ <a class="reference internal" href="../reference/commands/tokenize.html"><span class="doc">tokenize</span></a> ] Added “mode” option to control behavior.
You can use <code class="docutils literal notranslate"><span class="pre">GET</span></code> or <code class="docutils literal notranslate"><span class="pre">ADD</span></code> as a mode.
[GitHub#191] [GitHub#192] [Patch by Naoya Murakami]</p></li>
<li><p>Supported near search by ‘*N”A Z”’ syntax.</p></li>
<li><p>Supported to customize behavior of tokenizer whether it skips token or
skips token with position. This feature is useful for developing tokenizer plugin.
[GitHub#193] [Patch by Naoya Murakami]</p></li>
<li><p>[doc] Updated description that a bug report is accepted in Japanese on GitHub issue tracker.
[Reported by 6elz] [groonga-dev,02651]</p></li>
<li><p>[doc] Updated tutorial in English. [GitHub#194] [Patch by cosmo0920]</p></li>
</ul>
</div>
<div class="section" id="id15">
<h3>Fixes<a class="headerlink" href="#id15" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>[php] Fixed memory leak when <code class="xref c c-func docutils literal notranslate"><span class="pre">grn_ctx_recv()</span></code> is used.
[GitHub#184] [Patch by &#64;do-aki]</p></li>
<li><p>[php] Fixed to avoid double free when <a class="reference internal" href="../reference/api/grn_ctx.html#c.grn_ctx_close" title="grn_ctx_close"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_ctx_close()</span></code></a> is called.
[GitHub#184] [Patch by &#64;do-aki]</p></li>
<li><p>Fixed to support out-of-tree build again.</p></li>
<li><p>[httpd] Updated bundled nginx version to the latest mainline (1.7.4). This update contains vulnerability fix.</p></li>
<li><p>Fixed a bug that infinite loop occurs sometimes when updating indexes.
[groonga-dev,02673] [Reported by MINAGAWA Sho]</p></li>
<li><p>Fixed a bug that document frequency is invalid when
<a class="reference internal" href="../reference/indexing.html#offline-index-construction"><span class="std std-ref">Offline index construction</span></a> is used.
[groonga-dev,02691] [Reported by Naoya Murakami]</p></li>
</ul>
</div>
<div class="section" id="id16">
<h3>Thanks<a class="headerlink" href="#id16" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>&#64;do-aki</p></li>
<li><p>Naoya Murakami</p></li>
<li><p>6elz</p></li>
<li><p>MINAGAWA Sho</p></li>
<li><p>cosmo0920</p></li>
</ul>
</div>
</div>
<div class="section" id="release-4-0-4-2014-07-29">
<span id="release-4-0-4"></span><h2>Release 4.0.4 - 2014-07-29<a class="headerlink" href="#release-4-0-4-2014-07-29" title="Permalink to this headline">¶</a></h2>
<div class="section" id="id17">
<h3>Improvements<a class="headerlink" href="#id17" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>[httpd] Updated bundled nginx version to the latest mainline (1.7.3).</p></li>
<li><p>Supported weight in vector column.</p></li>
<li><p>[ <a class="reference internal" href="../reference/executables/groonga-benchmark.html"><span class="doc">groonga-benchmark</span></a> ] Added missing description about HTTP.</p></li>
<li><p>[ <a class="reference internal" href="../tutorial.html"><span class="doc">Tutorial</span></a> ] Updated English tutorial documentation.</p></li>
<li><p>[example] Supported Ruby 1.9 or later for edict2grn.rb.</p></li>
<li><p>[http][admin] Updated to use English as default language. [GitHub#182]</p></li>
</ul>
</div>
<div class="section" id="id18">
<h3>Fixes<a class="headerlink" href="#id18" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>Fixed to show right syntax error location in response.</p></li>
<li><p>[httpd] Fixed build error on Clang. [GitHub clear-code/rurema-search#11] [Reported by niku]</p></li>
</ul>
</div>
<div class="section" id="id19">
<h3>Thanks<a class="headerlink" href="#id19" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>niku</p></li>
</ul>
</div>
</div>
<div class="section" id="release-4-0-3-2014-06-29">
<span id="release-4-0-3"></span><h2>Release 4.0.3 - 2014-06-29<a class="headerlink" href="#release-4-0-3-2014-06-29" title="Permalink to this headline">¶</a></h2>
<div class="section" id="id20">
<h3>Improvements<a class="headerlink" href="#id20" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>[experimental][ <a class="reference internal" href="../reference/executables/groonga-server-http.html"><span class="doc">Groonga HTTP server</span></a> ]
Supported POST.</p></li>
<li><p>[windows] Bundled libwinpthread-1.dll. Because newer
libgcc_s_sjlj-1.dll depends on libwinpthread-1.dll.
[groonga-dev,02398] [Reported by Masafumi Yokoyama]</p></li>
<li><p>[ <a class="reference internal" href="../reference/executables/groonga.html"><span class="doc">groonga executable file</span></a> ] Changed the default port number of
GQTP to 10043. Because server packages use 10043 by default.
[GitHub#172] [Patch by Naoya Murakami]</p></li>
<li><p>[ <a class="reference internal" href="../reference/commands/normalize.html"><span class="doc">normalize</span></a> ] Added more validations for invalid
argument.
[groonga-dev,02409][GitHub:#174]
[Reported by GMO Media, Inc.][Patch by Naoya Murakami]</p></li>
<li><p>[ <a class="reference internal" href="../reference/commands/tokenize.html"><span class="doc">tokenize</span></a> ] Added more validations for invalid
argument.</p></li>
<li><p>[ <a class="reference internal" href="../reference/executables/groonga-server-http.html"><span class="doc">Groonga HTTP server</span></a> ] Supported <code class="docutils literal notranslate"><span class="pre">Expect:</span>
<span class="pre">100-Continue</span></code> request.</p></li>
<li><p>Exported <code class="docutils literal notranslate"><span class="pre">grn_proc_get_type()</span></code>.</p></li>
<li><p>[ <a class="reference internal" href="../reference/executables/groonga-suggest-learner.html"><span class="doc">groonga-suggest-learner</span></a> ]
Added <code class="docutils literal notranslate"><span class="pre">--log-path</span></code> and <code class="docutils literal notranslate"><span class="pre">--log-level</span></code> options.</p></li>
<li><p>Deprecated <code class="docutils literal notranslate"><span class="pre">GRN_CTX_USE_QL</span></code>.</p></li>
<li><p>Deprecated <code class="docutils literal notranslate"><span class="pre">GRN_CTX_BATCH_MODE</span></code>.</p></li>
<li><p>Added <code class="docutils literal notranslate"><span class="pre">grn_text_printf()</span></code>.</p></li>
<li><p>Added <code class="docutils literal notranslate"><span class="pre">grn_text_vprintf()</span></code>.</p></li>
<li><p>Removed limitation of one query log size.</p></li>
<li><p>Added <a class="reference internal" href="../reference/api/plugin.html#c.grn_plugin_expr_var_init" title="grn_plugin_expr_var_init"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_plugin_expr_var_init()</span></code></a>.
[GitHub#175][Patch by Naoya Murakami]</p></li>
<li><p>Added <a class="reference internal" href="../reference/api/plugin.html#c.grn_plugin_command_create" title="grn_plugin_command_create"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_plugin_command_create()</span></code></a>.
[GitHub#175][Patch by Naoya Murakami]</p></li>
<li><p>[GitHub#176] Supported reference vector column with weight.</p></li>
<li><p>[plugin] Used public API instead of internal API.
[GitHub#177][GitHub#178] [Patch by Naoya Murakami]</p></li>
<li><p>[doc][plugin] Added plugin APIs.
[GitHub#179] [Patch by Naoya Murakami]</p></li>
<li><p>[windows] Re-supported Visual C++ 2010.
[groonga-dev,02454] [Reported by cosmo0920].</p></li>
</ul>
</div>
<div class="section" id="id21">
<h3>Fixes<a class="headerlink" href="#id21" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>[rpm][groonga-server-gqtp] Fixed a bug that HTTP protocol is used
not GQTP.
[GitHub#173] [Patch by Naoya Murakami]</p></li>
<li><p>[ <a class="reference internal" href="../reference/commands/select.html"><span class="doc">select</span></a> ] Fixed a crash bug when
<a class="reference internal" href="../reference/commands/select.html#select-adjuster"><span class="std std-ref">adjuster</span></a> has a syntax error.</p></li>
</ul>
</div>
<div class="section" id="id22">
<h3>Thanks<a class="headerlink" href="#id22" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>Masafumi Yokoyama</p></li>
<li><p>Naoya Murakami</p></li>
<li><p>GMO Media, Inc.</p></li>
<li><p>cosmo0920</p></li>
</ul>
</div>
</div>
<div class="section" id="release-4-0-2-2014-05-29">
<span id="release-4-0-2"></span><h2>Release 4.0.2 - 2014-05-29<a class="headerlink" href="#release-4-0-2-2014-05-29" title="Permalink to this headline">¶</a></h2>
<div class="section" id="id23">
<h3>Improvements<a class="headerlink" href="#id23" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>[doc] Updated documentation about
<a class="reference internal" href="../reference/executables/groonga-suggest-learner.html"><span class="doc">groonga-suggest-learner</span></a>.</p></li>
<li><p>[doc] Added documentation about how to update files.
[GitHub#160] [Patch by cosmo0920]</p></li>
<li><p>[doc] Updated to caplitalized “Groonga” terms in
documentation. [GitHub#162][GitHub#163][GitHub#164]
[Patch by cosmo0920]</p></li>
<li><p>Supported Ubuntu 14.04 (Trusty Tahr).</p></li>
<li><p>Dropped Ubuntu 12.10.</p></li>
<li><p>Migrated Ubuntu package distribution site to PPA on Launchpad.
See <a class="reference internal" href="../install/ubuntu.html"><span class="doc">Ubuntu</span></a> for details.</p></li>
<li><p>Handled all requests that start with <code class="docutils literal notranslate"><span class="pre">/d/</span></code> as API requests. You
need to put files to directories that don’t start with <code class="docutils literal notranslate"><span class="pre">/d/</span></code> to
serve by Groonga HTTP service.</p></li>
<li><p>[munin] Supported <a class="reference internal" href="../reference/executables/groonga-httpd.html"><span class="doc">groonga-httpd</span></a>.
[Reported by Naoya Murakami]</p></li>
<li><p>Supported daylight saving time.
[#2546]</p></li>
<li><p>[doc] Added a description about <code class="docutils literal notranslate"><span class="pre">--with-mecab</span></code> in
<a class="reference internal" href="../install/mac_os_x.html"><span class="doc">Mac OS X</span></a>.</p></li>
<li><p>[http] Changed HTTP return code to <code class="docutils literal notranslate"><span class="pre">400</span> <span class="pre">Bad</span> <span class="pre">Request</span></code> from <code class="docutils literal notranslate"><span class="pre">500</span>
<span class="pre">Internal</span> <span class="pre">Server</span> <span class="pre">Error</span></code> for syntax error case.</p></li>
<li><p>[http][admin] Removed jQuery JSON plugin.
[GitHub#168] [Patch by Tetsuharu OHZEKI]</p></li>
<li><p>[http][admin] Enabled strict mode.
[GitHub#169] [Patch by Tetsuharu OHZEKI]</p></li>
<li><p>Exported getting variable APIs to <a class="reference internal" href="../reference/api/plugin.html"><span class="doc">Plugin</span></a>.
[GitHub#170] [Patch by Naoya Murakami]</p>
<ul>
<li><p>Added <code class="docutils literal notranslate"><span class="pre">grn_plugin_proc_get_var()</span></code>.</p></li>
<li><p>Added <code class="docutils literal notranslate"><span class="pre">grn_plugin_proc_get_var_by_offset()</span></code>.</p></li>
</ul>
</li>
<li><p>[experimental] Added <a class="reference internal" href="../reference/commands/tokenizer_list.html"><span class="doc">tokenizer_list</span></a>.
[GitHub#171] [Patch by Naoya Murakami]</p></li>
<li><p>[experimental] Added <a class="reference internal" href="../reference/commands/normalizer_list.html"><span class="doc">normalizer_list</span></a>.
[GitHub#171] [Patch by Naoya Murakami]</p></li>
</ul>
</div>
<div class="section" id="id24">
<h3>Fixes<a class="headerlink" href="#id24" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>[index] Fixed a bug that wrong max segment. It causes a crash when
you use all allocated resource for an index column.
[#2438] [Reported by GMO Media, Inc.]</p></li>
<li><p>[doc] Fixed a typo in <a class="reference internal" href="../install/centos.html"><span class="doc">CentOS</span></a>.
[GitHub#166] [Patch by Naoya Murakami]</p></li>
<li><p>[doc] Fixed the wrong default value of <code class="docutils literal notranslate"><span class="pre">drilldown_output_columns</span></code> in
<a class="reference internal" href="../reference/commands/select.html"><span class="doc">select</span></a>.
[GitHub#167] [Patch by Naoya Murakami]</p></li>
<li><p>[doc] Added a missing <code class="docutils literal notranslate"><span class="pre">\</span></code> escape exception in
<a class="reference internal" href="../reference/grn_expr/query_syntax.html"><span class="doc">Query syntax</span></a>.
[Reported by &#64;Yappo]</p></li>
</ul>
</div>
<div class="section" id="id25">
<h3>Thanks<a class="headerlink" href="#id25" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>cosmo0920</p></li>
<li><p>Naoya Murakami</p></li>
<li><p>Tetsuharu OHZEKI</p></li>
<li><p>GMO Media, Inc.</p></li>
<li><p>&#64;Yappo</p></li>
</ul>
</div>
</div>
<div class="section" id="release-4-0-1-2014-03-29">
<span id="release-4-0-1"></span><h2>Release 4.0.1 - 2014-03-29<a class="headerlink" href="#release-4-0-1-2014-03-29" title="Permalink to this headline">¶</a></h2>
<div class="section" id="id26">
<h3>Improvements<a class="headerlink" href="#id26" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>[doc] Added a link in return value to detailed header description (<a class="reference internal" href="../reference/command/output_format.html"><span class="doc">Output format</span></a>).</p></li>
<li><p>Supported to inspect vector and object value in JSON load.
It shows more details about data which is failed to load.</p></li>
<li><p>Added <code class="docutils literal notranslate"><span class="pre">adjuster</span></code> option to select command.
adjuster options accepts following syntax: INDEX_COLUMN &#64; STRING_LITERAL (* FACTOR).</p></li>
<li><p>Supported <a class="reference internal" href="../reference/columns/vector.html#weight-vector-column"><span class="std std-ref">Weight vector column</span></a>. You need to specify ‘COLUMN_VECTOR|WITH_WEIGHT’ flags
to create weight vector column.</p></li>
<li><p>Added missing MIN/MAX macros on SunOS. [GitHub#154] [Patch by Sebastian Wiedenroth]</p></li>
<li><p>Improved recycling garbage data. It suppress to increse database size.</p></li>
<li><p>[doc] Added documentation about GET parameters for <a class="reference internal" href="../reference/executables/groonga-suggest-httpd.html"><span class="doc">groonga-suggest-httpd</span></a>.</p></li>
<li><p>[doc] Added documentation about <a class="reference internal" href="../reference/column.html"><span class="doc">Column</span></a>.</p></li>
<li><p>[doc] Added documentation about <a class="reference internal" href="../reference/columns/vector.html"><span class="doc">Vector column</span></a>.</p></li>
<li><p>[column_list] Supported to show weight vector column.</p></li>
<li><p>[column_create] Added error check for creating multi column index without WITH_SECTION.</p></li>
<li><p>[httpd] Enabled stub status module (NginxHttpStubStatusModule) for groonga-httpd. [Suggested by Masahiro Nagano]</p></li>
</ul>
</div>
<div class="section" id="id27">
<h3>Fixes<a class="headerlink" href="#id27" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>Fixed a bug that a division overflow caused a fatal error.
For example, it occurs when you execute ‘COLUMN / -1’ operation to Int32 or Int64 column. [#2307]</p></li>
<li><p>Fixed a bug that ‘%’ operations performs ‘/’ operations. [#2307]</p></li>
<li><p>[doc] Fixed a wrong documentation about <a class="reference internal" href="../reference/commands/column_rename.html"><span class="doc">column_rename</span></a>. [Reported by nise_nabe]</p></li>
<li><p>Fixed the issue that out of bound array element access may occurs. [GitHub#158] [Reported by dcb314]</p></li>
</ul>
</div>
<div class="section" id="id28">
<h3>Thanks<a class="headerlink" href="#id28" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>Sebastian Wiedenroth</p></li>
<li><p>Masahiro Nagano</p></li>
<li><p>nise_nabe</p></li>
<li><p>dcb314</p></li>
</ul>
</div>
</div>
<div class="section" id="release-4-0-0-2014-02-09">
<span id="release-4-0-0"></span><h2>Release 4.0.0 - 2014-02-09<a class="headerlink" href="#release-4-0-0-2014-02-09" title="Permalink to this headline">¶</a></h2>
<ul class="simple">
<li><p>Bump version to 4.0.0!</p></li>
</ul>
<div class="section" id="id29">
<h3>Improvements<a class="headerlink" href="#id29" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>[normalizer] Supported to show “checks” which is used for calculating next character position.
Use WITH_CHECKS flag to enable this feature.</p></li>
<li><p>[deb] Dropped Ubuntu 13.04 support.</p></li>
</ul>
</div>
<div class="section" id="id30">
<h3>Fixes<a class="headerlink" href="#id30" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>Fixed a crash bug that an object in grn_expr is used after it is freed.
Normally Groonga server users aren’t affected this bug. This bug mainly affects Rroonga users.
Because this bug is occured by specifying column name including pseudo column name -
such as ‘_key’ - Rroonga users may use the usage.</p></li>
<li><p>Fixed not to execute unexpected cascade delete which is introduced Groonga 3.0.8 release.
If source’s range and index’s domain are different, Groonga doesn’t execute cascade delete.
[groonga-dev,02073] [Reported by yoku]</p></li>
<li><p>Fixed not to publish grn_snip structure. Use grn_obj instead of grn_snip.
If you use grn_snip_close, please replace grn_snip_close to grn_obj_close.</p></li>
<li><p>[snippet_html] Fixed a crash bug when –query is empty.
[groonga-dev,02097] [Reported by Naoya Murakami]</p></li>
<li><p>[snippet_html] Fixed to suppress ALERT level message when contents of column is empty text.
[groonga-dev,02097] [Reported by Naoya Murakami]</p></li>
<li><p>[groonga-httpd] Fixed a bug “off” is used as path name in groonga_query_log_path.
[groonga-dev,02113] [Reported by Ryoji Yamamoto]</p></li>
</ul>
</div>
<div class="section" id="id31">
<h3>Thanks<a class="headerlink" href="#id31" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>yoku</p></li>
<li><p>Naoya Murakami</p></li>
<li><p>Ryoji Yamamoto</p></li>
</ul>
</div>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">News - 4.x</a><ul>
<li><a class="reference internal" href="#release-4-1-1-2015-01-29">Release 4.1.1 - 2015-01-29</a><ul>
<li><a class="reference internal" href="#improvements">Improvements</a></li>
<li><a class="reference internal" href="#fixes">Fixes</a></li>
<li><a class="reference internal" href="#thanks">Thanks</a></li>
</ul>
</li>
<li><a class="reference internal" href="#release-4-1-0-2015-01-09">Release 4.1.0 - 2015-01-09</a><ul>
<li><a class="reference internal" href="#id1">Fixes</a></li>
</ul>
</li>
<li><a class="reference internal" href="#release-4-0-9-2014-12-29">Release 4.0.9 - 2014-12-29</a><ul>
<li><a class="reference internal" href="#id2">Improvements</a></li>
<li><a class="reference internal" href="#id3">Fixes</a></li>
<li><a class="reference internal" href="#id4">Thanks</a></li>
</ul>
</li>
<li><a class="reference internal" href="#release-4-0-8-2014-11-29">Release 4.0.8 - 2014-11-29</a><ul>
<li><a class="reference internal" href="#id5">Improvements</a></li>
<li><a class="reference internal" href="#id6">Fixes</a></li>
<li><a class="reference internal" href="#id7">Thanks</a></li>
</ul>
</li>
<li><a class="reference internal" href="#release-4-0-7-2014-10-29">Release 4.0.7 - 2014-10-29</a><ul>
<li><a class="reference internal" href="#id8">Improvements</a></li>
<li><a class="reference internal" href="#id9">Fixes</a></li>
<li><a class="reference internal" href="#id10">Thanks</a></li>
</ul>
</li>
<li><a class="reference internal" href="#release-4-0-6-2014-09-29">Release 4.0.6 - 2014-09-29</a><ul>
<li><a class="reference internal" href="#id11">Improvements</a></li>
<li><a class="reference internal" href="#id12">Fixes</a></li>
<li><a class="reference internal" href="#id13">Thanks</a></li>
</ul>
</li>
<li><a class="reference internal" href="#release-4-0-5-2014-08-29">Release 4.0.5 - 2014-08-29</a><ul>
<li><a class="reference internal" href="#id14">Improvements</a></li>
<li><a class="reference internal" href="#id15">Fixes</a></li>
<li><a class="reference internal" href="#id16">Thanks</a></li>
</ul>
</li>
<li><a class="reference internal" href="#release-4-0-4-2014-07-29">Release 4.0.4 - 2014-07-29</a><ul>
<li><a class="reference internal" href="#id17">Improvements</a></li>
<li><a class="reference internal" href="#id18">Fixes</a></li>
<li><a class="reference internal" href="#id19">Thanks</a></li>
</ul>
</li>
<li><a class="reference internal" href="#release-4-0-3-2014-06-29">Release 4.0.3 - 2014-06-29</a><ul>
<li><a class="reference internal" href="#id20">Improvements</a></li>
<li><a class="reference internal" href="#id21">Fixes</a></li>
<li><a class="reference internal" href="#id22">Thanks</a></li>
</ul>
</li>
<li><a class="reference internal" href="#release-4-0-2-2014-05-29">Release 4.0.2 - 2014-05-29</a><ul>
<li><a class="reference internal" href="#id23">Improvements</a></li>
<li><a class="reference internal" href="#id24">Fixes</a></li>
<li><a class="reference internal" href="#id25">Thanks</a></li>
</ul>
</li>
<li><a class="reference internal" href="#release-4-0-1-2014-03-29">Release 4.0.1 - 2014-03-29</a><ul>
<li><a class="reference internal" href="#id26">Improvements</a></li>
<li><a class="reference internal" href="#id27">Fixes</a></li>
<li><a class="reference internal" href="#id28">Thanks</a></li>
</ul>
</li>
<li><a class="reference internal" href="#release-4-0-0-2014-02-09">Release 4.0.0 - 2014-02-09</a><ul>
<li><a class="reference internal" href="#id29">Improvements</a></li>
<li><a class="reference internal" href="#id30">Fixes</a></li>
<li><a class="reference internal" href="#id31">Thanks</a></li>
</ul>
</li>
</ul>
</li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="nav-item nav-item-0"><a href="../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">News - 4.x</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>